	.text

	.extern		main
	.global		__startup
	.extern		_stack_base
#=========================================
#      Initialize vectors
#
##     0x00 	 Reset
##     0x04 	 Undefined Instruction
##     0x08 	 Software Interrupt
##     0x0c 	 Abort(prefetch)
##     0x10 	 Abort(data)
##     0x14 	 Reserved
##     0x18 	 IRQ
##     0x1c 	 FIQ
#=========================================

	B	__startup			/*$B"+%j%;%C%H%Y%/%?!#(B__startup$B$XJ,4t!#(B*/
	nop					/*$B"+L$Dj5AL?NaNc30$O;HMQ6X;_(B*/
	B	_software_exception		/*$B"+%=%U%H%&%'%"3d$j9~$_%Y%/%?!#(BSWI$BL?Na$NNc30$KH?1~$9$k$?$a!"Nc30%O%s%I%i$XJ,4t!#(B*/
	B	_prefetch_abort_handle		/*$B"+%W%j%U%'%C%A%"%\!<%HNc30!#JQ$J%"%I%l%9$r%"%/%;%9$7$?$H$-$KH/@8!#%;!<%U%F%#%M%C%H$H$7$FEPO?!#(B*/
	nop
	nop
	B	_IRQ_handle			/*$B"+(BIRQ$BNc30%Y%/%?!#(BIRQ$BNc30%O%s%I%i$XJ,4t!#(B*/
	B	_FIQ_handle			/*$B"+(BFIQ$BNc30%Y%/%?!#(BFIQ$BNc30%O%s%I%i$XJ,4t!#(B*/
	.org 0x20	
__startup:
.ifdef ROM_TARGET				/*$B"-(B(A) ROM$B2=;~$N$_;HMQ$5$l$k!#$3$NItJ,$O%W%m%;%C%5$N5/F0D>8e$K<B9T$5$l$k$Y$-=i4|2=A`:n$,5-=R$5$l$k!#(B*/

	#IRQ$BDLCN$r<u$1<h$k$h$&$K@_Dj$9$k(B
	MRS	R0, cpsr
	eor	R0, R0, #0x80
	MSR	cpsr, R0
.endif /* ROM_TARGET */				/*$B",(B(A)*/

	LDR	R13,=_stack_base		/*$B"+%9!<%Q!<%P%$%6%b!<%I$N%9%?%C%/$r@_Dj$9$k!#(B*/

	#$B%W%m%;%C%5%b!<%I$r(BIRQ$B%b!<%I$X(B		
	MRS	r1, CPSR			/*$B"-(BIRQ$B%b!<%I$N%9%?%C%/$r@_Dj$9$k!#(B*/
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x12
	MSR	CPSR, R1
	ORR	R1, R1, #0x13
	MSR	SPSR, R1
	#$BNc30%O%s%I%iMQ%9%?%C%/$r@_Dj(B
	LDR	sp, = _exception_stack_base	/*$B",(B*/
	#$B%W%m%;%C%5%b!<%I$rL$Dj5AL?NaNc30%b!<%I$X(B	
	MRS	r1, CPSR			/*$B"-L$Dj5AL?NaNc30%b!<%I$N%9%?%C%/$r@_Dj$9$k!#(B*/
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x1B
	MSR	CPSR, R1
	ORR	R1, R1, #0x13
	MSR	SPSR, R1
	#$BNc30%O%s%I%iMQ%9%?%C%/$r@_Dj(B
	LDR	sp, = _exception_stack_base	/*$B",(B*/
	#$B%W%m%;%C%5%b!<%I$r(Babt$B%b!<%I$X(B	
	MRS	r1, CPSR			/*$B"-%"%\!<%HNc30%b!<%I$N%9%?%C%/$r@_Dj$9$k!#(B*/
	BIC	R1, R1, #0x1F
	ORR	R1, R1, #0x17
	MSR	CPSR, R1
	ORR	R1, R1, #0x13
	MSR	SPSR, R1
	#$BNc30%O%s%I%iMQ%9%?%C%/$r@_Dj(B
	LDR	sp, = _exception_stack_base	/*$B",(B*/
	#$B%W%m%;%C%5%b!<%I$r%9!<%Q!<%P%$%6%b!<%I$XLa$9(B
	BIC	R1, R1, #0x1F			
	ORR	R1, R1, #0x13
	MSR	CPSR, R1

.ifdef ROM_TARGET				/*$B"-(B(B) ROM$B2=;~$N$_;HMQ$5$l$k!#$3$NItJ,$O%W%m%;%C%5$N5/F0D>8e$K<B9T$5$l$k$Y$-=i4|2=A`:n$,5-=R$5$l$k!#(B*/
	#$B30It(BRAM$BNN0h$r@_Dj$9$k!#$J$$>l9g$O%3%a%s%H%"%&%H$7$F$/$@$5$$!#(B
	BL	enable_EM0
	BL	enable_EM1
	BL	enable_EM2
	BL	enable_EM3
	BL	enable_XMCFG
	
	/* data$B%;%/%7%g%s$r(BROM->RAM$B%3%T!<(B */	/*$B"-(BROM$B$KJ]B8$5$l$F$$$k=i4|2=:Q$_$N(Bdata$B%;%/%7%g%s$r(BRAM$BNN0h$K%3%T!<$9$k!#(B*/
	LDR	r1, =_sdata_loadaddr
	LDR	r2, =_sdata
	LDR	r3, =_edata			
__copy_loop:	
	LDRB	r4, [r1]
	STRB	r4, [r2, #0]
	ADD	r1, r1, #1
	ADD	r2, r2, #1
	CMP     r3, r2
	BGT	__copy_loop			/*$B",(B*/
.endif /* ROM_TARGET */				/*$B",(B(B)*/

.ifndef ROM_TARGET				/*$B"-(B(C)ROM$B2=;~$O:o=|$5$l$k(B*/
	STMDB	sp!,{r0-r12, r14}		/*$B"-%9%?%V$+$i%@%&%s%m!<%I%W%m%0%i%`$r<B9T$9$k$H$-!"%9%?%V$G;H$C$F$$$?%l%8%9%?FbMF$rB`Hr$9$kI,MW$,$"$k!#(B*/
	MRS	r0, spsr
	STMDB	sp!, {r0}			/*$B",(B*/

	LDR	r0, =_user_exception_vector_addr
	LDR	r1, =_user_vector_base_addr
	STR	r1, [r0]			/*$B",(B(C)*/
.endif /* !ROM_TARGET */

.ifdef THUMB
	LDR     R1,=main
	ORR     R1, R1 ,#1
	BX      R1
.else
	BL	main	/*$B"+(Bmain$B4X?t$XJ,4t$9$k!#(B*/
.endif
	
.ifndef ROM_TARGET				/*$B"-(B(D)ROM$B2=;~$O:o=|$5$l$k!#%9%?%C%/$+$i%l%8%9%?$rI|5"$7$F!"%9%?%V$GJ]B8$5$l$?(Blp$B$NFbMF!"$D$^$j!"%9%?%V$G%@%&%s%m!<%I%W%m%0%i%`$,8F$P$l$?%"%I%l%9$K%j%?!<%s$9$k!#(B*/
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12,r14}
	MOVS	PC, R14
.endif /* !ROM_TARGET */			/*$B",(B(D)*/

_loop_here:				/*$B"+(BROM$B2=;~$K8m$C$F$3$3$^$GMh$?$H$-$KL58B%k!<%W$K4Y$i$;$k$?$a$N%;%$%U%F%#%M%C%H!#(B*/
	B	_loop_here

	.align 0x4
_software_exception:			/*$B"+%=%U%H%&%'%"Nc30%O%s%I%i(B*/
.ifndef ROM_TARGET			/*$B"-(BROM$B2=$N$H$-$O:o=|$5$l$k!#(B*/
	#$BNc30MQ%9%?%C%/$+$i%l%8%9%?I|5"(B	
	LDMIA	sp!, {r0}		/*$B"+(Br0$B$,(BGDB$B%9%?%V$GBTHr$5$l$k$?$a!"$3$3$GI|5"$5$;$k!#(B*/
.endif /* !ROM_TARGET */		/*$B",(B*/

	#$BNc30MQ%9%?%C%/$K%l%8%9%?B`Hr(B	
	STMDB	sp!,{r0-r12, r14}
	MRS	r0, spsr
	STMDB	sp!, {r0}

	bl	software_exception_func	/*$B"+(BC$B4X?t$XJ,4t(B*/
		
	#$BNc30MQ%9%?%C%/$+$i%l%8%9%?I|5"(B	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12,r14}
	
	MOVS	PC, R14			/*$B"+Nc30H/@8HVCO$XI|5"(B*/
		
	.align 0x4
_prefetch_abort_handle:			/*$B"+%"%\!<%HNc30%O%s%I%i(B*/
.ifndef ROM_TARGET			/*$B"-(BROM$B2=$N$H$-$O:o=|$5$l$k!#(B*/
	#$BNc30MQ%9%?%C%/$+$i%l%8%9%?I|5"(B	/*$B"+(Br0$B$,(BGDB$B%9%?%V$GBTHr$5$l$k$?$a!"$3$3$GI|5"$5$;$k!#(B*/
	LDMIA	sp!, {r0}
.endif /* !ROM_TARGET */		/*$B",(B*/

	#$BNc30MQ%9%?%C%/$K%l%8%9%?B`Hr(B	
	STMDB	sp!,{r0-r12, r14}
	MRS	r0, spsr
	STMDB	sp!, {r0}

	bl	prefetch_abort_func	/*$B"+(BC$B4X?t$XJ,4t(B*/
		
	#$BNc30MQ%9%?%C%/$+$i%l%8%9%?I|5"(B	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12,r14}
	
	SUBS	PC, R14, #4		/*$B"+Nc30H/@8HVCO$XI|5"(B*/
	
	.align 0x4
_IRQ_handle:				/*$B"+(BIRQ$BNc30%O%s%I%i(B*/
.ifndef ROM_TARGET			/*$B"-(BROM$B2=$N$H$-$O:o=|$5$l$k!#(B*/
	#$BNc30MQ%9%?%C%/$+$i%l%8%9%?I|5"(B	
	LDMIA	sp!, {r0}		/*$B"+(Br0$B$,(BGDB$B%9%?%V$GBTHr$5$l$k$?$a!"$3$3$GI|5"$5$;$k!#(B*/
.endif /* !ROM_TARGET */		/*$B",(B*/

	#$BNc30MQ%9%?%C%/$K%l%8%9%?B`Hr(B	
	STMDB	sp!,{r0-r12, r14}
	MRS	r0, spsr
	STMDB	sp!, {r0}

	bl	IRQ_func		/*$B"+(BC$B4X?t$XJ,4t(B*/
		
	#$BNc30MQ%9%?%C%/$+$i%l%8%9%?I|5"(B	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12,r14}
		
	SUBS	PC, R14, #4

	.align 0x4
_FIQ_handle:				/*$B"+(BFIQ$BNc30%O%s%I%i(B*/
.ifndef ROM_TARGET
	#$BNc30MQ%9%?%C%/$+$i%l%8%9%?I|5"(B	/*$B"-(BROM$B2=$N$H$-$O:o=|$5$l$k!#(B*/
	LDMIA	sp!, {r0}		/*$B"+(Br0$B$,(BGDB$B%9%?%V$GBTHr$5$l$k$?$a!"$3$3$GI|5"$5$;$k!#(B*/
.endif /* !ROM_TARGET */		/*$B",(B*/

	#$BNc30MQ%9%?%C%/$K%l%8%9%?B`Hr(B	
	STMDB	sp!,{r0-r12, r14}
	MRS	r0, spsr
	STMDB	sp!, {r0}

	bl	FIQ_func		/*$B"+(BC$B4X?t$XJ,4t(B*/
		
	#$BNc30MQ%9%?%C%/$+$i%l%8%9%?I|5"(B	
	LDMIA	sp!, {r0}
	MSR	spsr_cf, r0
	LDMIA	sp!,{r0-r12,r14}
	
	SUBS	PC, R14, #4		/*$B"+Nc30H/@8HVCO$XI|5"(B*/
