	.text

	.extern		main
	.extern		_illegalinst_func
	.extern		_int_func
	.extern		registers
	.global		__reset_vector
#===========================
#      Exception Vectors
#===========================
__reset_vector:	
	# $B%Q%o!<%*%s%j%;%C%HNc30(B 0x0-0x4
	bri	__startup
	bri	__startup
	# $B%f!<%6%Y%/%?Nc30(B 0x8-0xC
	.org	0x8
	bri	__user_vector_exception
	bri	__user_vector_exception
	# $B30It3d9~$_Nc30(B 0x10-0x14
	.org	0x10
	bri	__int_exception
	bri	__int_exception
	# NMI$B!"%O!<%I%&%'%"%V%l!<%/!"%=%U%H%&%'%"%V%l!<%/Nc30(B 0x18-0x1C
	.org	0x18
	bri	__break_exception
	bri	__break_exception
	# $B%O!<%I%&%'%"Nc30(B 0x20-0x24
	.org	0x20
	bri	__hardware_exception
	bri	__hardware_exception
	# $B%j%6!<%V(B 0x28-0x4F
	.org 0x28

	.org 0x50
__startup:
	#$B%9%?%C%/$r@_Dj$9$k!#(B
	xor r1, r1, r1
	addik r1, r0, _sp_base
	bri main
	nop

	# $BL$Dj5AL?NaNc30$,H/@8$7$?$H$-$K<B9T$5$l$k!#%9%?%V$,@jM-$7$^$9!#(B
__hardware_exception:
	# $B%l%8%9%?$r%9%?%V$N%l%8%9%?NN0h$K%3%T!<(B
	# r0
	swi	r0, r0, registers
	# r1
	swi	r1, r0, registers+0x04
	# r2
	swi	r2, r0, registers+0x08
	# r3
	swi	r3, r0, registers+0x0c
	# r4
	swi	r4, r0, registers+0x10
	# r5
	swi	r5, r0, registers+0x14
	# r6
	swi	r6, r0, registers+0x18
	# r7
	swi	r7, r0, registers+0x1c
	# r8
	swi	r8, r0, registers+0x20
	# r9
	swi	r9, r0, registers+0x24
	# r10
	swi	r10, r0, registers+0x28
	# r11
	swi	r11, r0, registers+0x2c
	# r12
	swi	r12, r0, registers+0x30
	# r13
	swi	r13, r0, registers+0x34
	# r14
	swi	r14, r0, registers+0x38
	# r15
	swi	r15, r0, registers+0x3c
	# r16
	swi	r16, r0, registers+0x40
	# r17
	swi	r17, r0, registers+0x44
	# r18
	swi	r18, r0, registers+0x48
	# r19
	swi	r19, r0, registers+0x4c
	# r20
	swi	r20, r0, registers+0x50
	# r21
	swi	r21, r0, registers+0x54
	# r22
	swi	r22, r0, registers+0x58
	# r23
	swi	r23, r0, registers+0x5c
	# r24
	swi	r24, r0, registers+0x60
	# r25
	swi	r25, r0, registers+0x64
	# r26
	swi	r26, r0, registers+0x68
	# r27
	swi	r27, r0, registers+0x6c
	# r28
	swi	r28, r0, registers+0x70
	# r29
	swi	r29, r0, registers+0x74
	# r30
	swi	r30, r0, registers+0x78
	# r31
	swi	r31, r0, registers+0x7c
	# PC
	swi	r17, r0, registers+0x80
	# MSR
	mfs     r31, rmsr
	swi	r31, r0, registers+0x84
	# EAR
	mfs     r31, rear
	swi	r31, r0, registers+0x88
	# ESR
	mfs     r31, resr
	swi	r31, r0, registers+0x8c
	# FSR
	mfs     r31, rfsr
	swi	r31, r0, registers+0x90

	
        brlid   r15, _illegalinst_func
        nop

	# $B%l%8%9%?$rI|5"(B
	# r0
	lwi	r0, r0, registers
	# r1
	lwi	r1, r0, registers+0x04
	# r2
	lwi	r2, r0, registers+0x08
	# r3
	lwi	r3, r0, registers+0x0c
	# r4
	lwi	r4, r0, registers+0x10
	# r5
	lwi	r5, r0, registers+0x14
	# r6
	lwi	r6, r0, registers+0x18
	# r7
	lwi	r7, r0, registers+0x1c
	# r8
	lwi	r8, r0, registers+0x20
	# r9
	lwi	r9, r0, registers+0x24
	# r10
	lwi	r10, r0, registers+0x28
	# r11
	lwi	r11, r0, registers+0x2c
	# r12
	lwi	r12, r0, registers+0x30
	# r13
	lwi	r13, r0, registers+0x34
	# r14
	lwi	r14, r0, registers+0x38
	# r15
	lwi	r15, r0, registers+0x3c
	# r16
	lwi	r16, r0, registers+0x40
	# r17
	lwi	r17, r0, registers+0x44
	# r18
	lwi	r18, r0, registers+0x48
	# r19
	lwi	r19, r0, registers+0x4c
	# r20
	lwi	r20, r0, registers+0x50
	# r21
	lwi	r21, r0, registers+0x54
	# r22
	lwi	r22, r0, registers+0x58
	# r23
	lwi	r23, r0, registers+0x5c
	# r24
	lwi	r24, r0, registers+0x60
	# r25
	lwi	r25, r0, registers+0x64
	# r26
	lwi	r26, r0, registers+0x68
	# r27
	lwi	r27, r0, registers+0x6c
	# r28
	lwi	r28, r0, registers+0x70
	# r29
	lwi	r29, r0, registers+0x74
	# r30
	lwi	r30, r0, registers+0x78
	# r31
	lwi	r31, r0, registers+0x7c

        rted    r17, 4
	nop
	
	.extern _int_handler
__int_exception:
	#$B%9%?%C%/$K(Br30, r31$B$rBTHr(B
	swi	r31, r1, -4
	swi	r30, r1, -8

	# UART$B$+$i$N3d$j9~$_$+$I$&$+$rH=Dj$9$k!#(B	
.ifdef BLANCA_UART
	lwi	r30, r0, 0xBE000010 /*COM_IntStatus COM1*/
	/*lwi	r30, r0, 0x88000010*/ /*COM_IntStatus COM2*/
	andi	r30, r30, 1
.endif /* BLANCA_UART */
.ifdef MB_UART
	lwi	r30, r0, 0xBE000020 /*COM_CtrlReg COM1*/
	/*lwi	r30, r0, 0x88000020*/ /*COM_CtrlReg COM2*/
	andi	r30, r30, 1
.endif /* MB_UART */
	lwi	r31, r0, _user_exception_vector_addr
	addi	r31, r31, 0x10
	beqid	r30, __jmp_user_int	/*$B"+%G!<%?$r<u?.$7$F$$$J$$$H$-%f!<%6$NNc30%O%s%I%i$X(B*/
	lwi	r30, r1, -8	/*$B"+CY1d%9%m%C%H$r;H$C$F(Br30$B$rLa$9(B*/
	bri	__jmp_gdb_int
__jmp_user_int:
	brad	r31
__jmp_gdb_int:	
	lwi	r31, r1, -4	/*$B"+CY1d%9%m%C%H$r;H$C$F(Br31$B$rLa$9(B*/
	# $B%l%8%9%?$r%9%?%V$N%l%8%9%?NN0h$K%3%T!<(B
	# r0
	swi	r0, r0, registers
	# r1
	swi	r1, r0, registers+0x04
	# r2
	swi	r2, r0, registers+0x08
	# r3
	swi	r3, r0, registers+0x0c
	# r4
	swi	r4, r0, registers+0x10
	# r5
	swi	r5, r0, registers+0x14
	# r6
	swi	r6, r0, registers+0x18
	# r7
	swi	r7, r0, registers+0x1c
	# r8
	swi	r8, r0, registers+0x20
	# r9
	swi	r9, r0, registers+0x24
	# r10
	swi	r10, r0, registers+0x28
	# r11
	swi	r11, r0, registers+0x2c
	# r12
	swi	r12, r0, registers+0x30
	# r13
	swi	r13, r0, registers+0x34
	# r14
	swi	r14, r0, registers+0x38
	# r15
	swi	r15, r0, registers+0x3c
	# r16
	swi	r16, r0, registers+0x40
	# r17
	swi	r17, r0, registers+0x44
	# r18
	swi	r18, r0, registers+0x48
	# r19
	swi	r19, r0, registers+0x4c
	# r20
	swi	r20, r0, registers+0x50
	# r21
	swi	r21, r0, registers+0x54
	# r22
	swi	r22, r0, registers+0x58
	# r23
	swi	r23, r0, registers+0x5c
	# r24
	swi	r24, r0, registers+0x60
	# r25
	swi	r25, r0, registers+0x64
	# r26
	swi	r26, r0, registers+0x68
	# r27
	swi	r27, r0, registers+0x6c
	# r28
	swi	r28, r0, registers+0x70
	# r29
	swi	r29, r0, registers+0x74
	# r30
	swi	r30, r0, registers+0x78
	# r31
	swi	r31, r0, registers+0x7c
	# PC
	swi	r14, r0, registers+0x80
	# MSR
	mfs     r31, rmsr
	swi	r31, r0, registers+0x84
	# EAR
	mfs     r31, rear
	swi	r31, r0, registers+0x88
	# ESR
	mfs     r31, resr
	swi	r31, r0, registers+0x8c
	# FSR
	mfs     r31, rfsr
	swi	r31, r0, registers+0x90

        brlid   r15, _int_func
        nop

	# $B%l%8%9%?$rI|5"(B
	# r0
	lwi	r0, r0, registers
	# r1
	lwi	r1, r0, registers+0x04
	# r2
	lwi	r2, r0, registers+0x08
	# r3
	lwi	r3, r0, registers+0x0c
	# r4
	lwi	r4, r0, registers+0x10
	# r5
	lwi	r5, r0, registers+0x14
	# r6
	lwi	r6, r0, registers+0x18
	# r7
	lwi	r7, r0, registers+0x1c
	# r8
	lwi	r8, r0, registers+0x20
	# r9
	lwi	r9, r0, registers+0x24
	# r10
	lwi	r10, r0, registers+0x28
	# r11
	lwi	r11, r0, registers+0x2c
	# r12
	lwi	r12, r0, registers+0x30
	# r13
	lwi	r13, r0, registers+0x34
	# r14
	lwi	r14, r0, registers+0x38
	# r15
	lwi	r15, r0, registers+0x3c
	# r16
	lwi	r16, r0, registers+0x40
	# r17
	lwi	r17, r0, registers+0x44
	# r18
	lwi	r18, r0, registers+0x48
	# r19
	lwi	r19, r0, registers+0x4c
	# r20
	lwi	r20, r0, registers+0x50
	# r21
	lwi	r21, r0, registers+0x54
	# r22
	lwi	r22, r0, registers+0x58
	# r23
	lwi	r23, r0, registers+0x5c
	# r24
	lwi	r24, r0, registers+0x60
	# r25
	lwi	r25, r0, registers+0x64
	# r26
	lwi	r26, r0, registers+0x68
	# r27
	lwi	r27, r0, registers+0x6c
	# r28
	lwi	r28, r0, registers+0x70
	# r29
	lwi	r29, r0, registers+0x74
	# r30
	lwi	r30, r0, registers+0x78
	# r31
	lwi	r31, r0, registers+0x7c

        rtid    r14, 4
	nop

__user_vector_exception:
	#$B%9%?%C%/$K(Br2$B$rBTHr(B
	swi	r2, r1, -4
	lwi	r2, r0, _user_exception_vector_addr
	addi	r2, r2, 0x8
	brad	r2
	lwi	r2, r1, -4	/*$B"+CY1d%9%m%C%H$r;H$C$F(Br2$B$rLa$9(B*/
	
__break_exception:
	#$B%9%?%C%/$K(Br2$B$rBTHr(B
	swi	r2, r1, -4
	lwi	r2, r0, _user_exception_vector_addr
	addi	r2, r2, 0x18
	brad	r2
	lwi	r2, r1, -4	/*$B"+CY1d%9%m%C%H$r;H$C$F(Br2$B$rLa$9(B*/
	