	.text

	.extern	main
	.extern int_handler
	.set noat
#====================================
#      Exception Vectors
#====================================
	# RESET
__reset_vector:				#$B"+%j%;%C%H%Y%/%?(B
	j	__startup
	nop
	.org 0x180
	j	__global_exception_handler
	nop
# GDB$B$G$O$3$3$+$i<B9T$,;O$^$j$^$9!#(B	
.org 0x400
	.global	__startup 
__startup:
.ifdef ROM_TARGET		#$B"-(B(A) ROM$B2=;~$N$_;HMQ$5$l$k!#$3$NItJ,$O%W%m%;%C%5$N5/F0D>8e$K<B9T$5$l$k$Y$-=i4|2=A`:n$,5-=R$5$l$k!#(B
	/* data$B%;%/%7%g%s$r(BROM->RAM$B%3%T!<(B */	#$B"-(BROM$B$KJ]B8$5$l$F$$$k=i4|2=:Q$_$N(Bdata$B%;%/%7%g%s$r(BRAM$BNN0h$K%3%T!<$9$k!#(B
	la	$1, _sdata_loadaddr
	la	$2, _sdata
	la	$3, _edata
__copy_loop:
	lbu	$4, 0($1)
	sb	$4, 0($2)
	addi	$1, $1, 1
	addi	$2, $2, 1
	sub	$4, $3, $2
	bgtz	$4, __copy_loop
	nop					#$B",(B
.endif /* ROM_TARGET */	#$B",(B(A)
	
	# $B%9%?%C%/$r@_Dj$9$k(B
	la	$sp, _stack_base	#$B"+%f!<%6%W%m%0%i%`B&$G%9%?%C%/$r@_Dj(B
	

.ifndef ROM_TARGET		#$B"-(B(B)$B%f!<%6%W%m%0%i%`%G%P%C%0;~$N$_<B9T$9$k!%(BROM$B2=;~$O:o=|$5$l$k!%(B
	/* $B%9%?%C%/$K%l%8%9%?$rB`Hr$9$k(B*/
	addiu	$sp, $sp, -132
	sw	$1, 0($sp)
	sw	$2, 4($sp)
	sw	$3, 8($sp)
	sw	$4, 12($sp)
	sw	$5, 16($sp)
	sw	$6, 20($sp)
	sw	$7, 24($sp)
	sw	$8, 28($sp)
	sw	$9, 32($sp)
	sw	$10, 36($sp)
	sw	$11, 40($sp)
	sw	$12, 44($sp)
	sw	$13, 48($sp)
	sw	$14, 52($sp)
	sw	$15, 56($sp)
	sw	$16, 60($sp)
	sw	$17, 64($sp)
	sw	$18, 68($sp)
	sw	$19, 72($sp)
	sw	$20, 76($sp)
	sw	$21, 80($sp)
	sw	$22, 84($sp)
	sw	$23, 88($sp)
	sw	$24, 92($sp)
	sw	$25, 96($sp)
	sw	$26, 100($sp)
	sw	$27, 104($sp)
	sw	$28, 108($sp)
	sw	$29, 112($sp)
	sw	$30, 116($sp)
	sw	$31, 120($sp)
	mfhi	$1
	sw	$1, 124($sp)
	mflo	$1
	sw	$1, 128($sp)
	
	# $B%f!<%6Nc30%Y%/%?$N%Y!<%9%"%I%l%9$r@_Dj$7$^$9!#(B
	la	$1, _user_exception_vector_addr	#$B"-FbB"(BRAM$B$N:G>e0L$N(B4$B%P%$%H$K!"BeBX%Y%/%?$N%"%I%l%9$r3JG<$9$k(B
	la	$2, _user_vector_base_addr
	sw	$2, 0($1)		#$B",(B

	jal	main			#$B"+(Bmain()$B4X?t$K%8%c%s%W(B
	nop

	lw	$1, 124($sp)		#$B"-B`Hr$7$?HFMQ%l%8%9%?$NFbMF$rI|5"(B
	mthi	$1
	lw	$1, 128($sp)
	mtlo	$1
	lw	$1, 0($sp)
	lw	$2, 4($sp)
	lw	$3, 8($sp)
	lw	$4, 12($sp)
	lw	$5, 16($sp)
	lw	$6, 20($sp)
	lw	$7, 24($sp)
	lw	$8, 28($sp)
	lw	$9, 32($sp)
	lw	$10, 36($sp)
	lw	$11, 40($sp)
	lw	$12, 44($sp)
	lw	$13, 48($sp)
	lw	$14, 52($sp)
	lw	$15, 56($sp)
	lw	$16, 60($sp)
	lw	$17, 64($sp)
	lw	$18, 68($sp)
	lw	$19, 72($sp)
	lw	$20, 76($sp)
	lw	$21, 80($sp)
	lw	$22, 84($sp)
	lw	$23, 88($sp)
	lw	$24, 92($sp)
	lw	$25, 96($sp)
	lw	$26, 100($sp)
	lw	$27, 104($sp)
	lw	$28, 108($sp)
	lw	$29, 112($sp)
	lw	$30, 116($sp)
	lw	$31, 120($sp)
	addiu	$sp, $sp, 132

	jr	$31			#$B%9%?%V$GJ]B8$5$l$?(Br31$B$NFbMF!"$D$^$j!"%9%?%V$G%@%&%s%m!<%I%W%m%0%i%`$,8F$P$l$?%"%I%l%9$K%j%?!<%s$9$k!#(B
	nop
.endif /* !ROM_TARGET */		#$B",(B(B)

.ifdef ROM_TARGET			#$B"-(B(C)$B%f!<%6%W%m%0%i%`(BROM$B2=;~$N$_<B9T$9$k!%%G%P%C%0;~$O:o=|$5$l$k!%(B

	jal	main			#$B"+(Bmain()$B4X?t$KLa$jHVCO$r(Br31$B$KJ]B8$7$FJ,4t$9$k!#(B
	nop
.endif /* ROM_TARGET */
	
_loop_here:				#$B"+(BROM$B2=;~$K8m$C$F$3$3$^$GMh$?$H$-$KL58B%k!<%W$K4Y$i$;$k$?$a$N%;%$%U%F%#%M%C%H!#(B
	j	_loop_here

__global_exception_handler:		#$B"+Nc30%Y%/%?$+$i8F$P$l$k%0%m!<%P%k$NNc30%O%s%I%i!#$3$N4X?t$G$I$NNc30$,H/@8$7$F$$$k$+$rH=Dj$9$k!#(B
.ifndef ROM_TARGET			#$B"-(B(D)ROM$B2=;~$O:o=|$5$l$k!#(B
	addiu	$sp, $sp, 4		#$B"-%9%?%V$NNc30%O%s%I%i$G%9%?%C%/%]%$%s%?$,?J$s$G$$$k$N$G$=$l$rLa$9(B
.endif	/* !ROM_TARGET */		#$B",(B(C)
	
	
	/* $B%9%?%C%/$K%l%8%9%?$rB`Hr$9$k(B*/
	addiu	$sp, $sp, -132		#$B"-%9%?%C%/$K%l%8%9%?$rB`Hr$9$k!#(B
	sw	$1, 0($sp)
	sw	$2, 4($sp)
	sw	$3, 8($sp)
	sw	$4, 12($sp)
	sw	$5, 16($sp)
	sw	$6, 20($sp)
	sw	$7, 24($sp)
	sw	$8, 28($sp)
	sw	$9, 32($sp)
	sw	$10, 36($sp)
	sw	$11, 40($sp)
	sw	$12, 44($sp)
	sw	$13, 48($sp)
	sw	$14, 52($sp)
	sw	$15, 56($sp)
	sw	$16, 60($sp)
	sw	$17, 64($sp)
	sw	$18, 68($sp)
	sw	$19, 72($sp)
	sw	$20, 76($sp)
	sw	$21, 80($sp)
	sw	$22, 84($sp)
	sw	$23, 88($sp)
	sw	$24, 92($sp)
	sw	$25, 96($sp)
	sw	$26, 100($sp)
	sw	$27, 104($sp)
	sw	$28, 108($sp)
	sw	$29, 112($sp)
	sw	$30, 116($sp)
	sw	$31, 120($sp)
	mfhi	$1
	sw	$1, 124($sp)
	mflo	$1
	sw	$1, 128($sp)		#$B",(B

	mfc0	$2, $13			#$B"+(BCAUSE$B$r(B_global_handler_func$B4X?t$NBh0l0z?t$K%;%C%H$7$F!"J,4t$9$k!#(B
	la	$1, __global_exception_func
	jalr	$1
	nop

	lw	$1, 124($sp)		#$B"-%l%8%9%?$r%9%?%C%/$+$iI|5"!#(B
	mthi	$1
	lw	$1, 128($sp)
	mtlo	$1
	lw	$1, 0($sp)
	lw	$2, 4($sp)
	lw	$3, 8($sp)
	lw	$4, 12($sp)
	lw	$5, 16($sp)
	lw	$6, 20($sp)
	lw	$7, 24($sp)
	lw	$8, 28($sp)
	lw	$9, 32($sp)
	lw	$10, 36($sp)
	lw	$11, 40($sp)
	lw	$12, 44($sp)
	lw	$13, 48($sp)
	lw	$14, 52($sp)
	lw	$15, 56($sp)
	lw	$16, 60($sp)
	lw	$17, 64($sp)
	lw	$18, 68($sp)
	lw	$19, 72($sp)
	lw	$20, 76($sp)
	lw	$21, 80($sp)
	lw	$22, 84($sp)
	lw	$23, 88($sp)
	lw	$24, 92($sp)
	lw	$25, 96($sp)
	lw	$26, 100($sp)
	lw	$27, 104($sp)
	lw	$28, 108($sp)
	lw	$29, 112($sp)
	lw	$30, 116($sp)
	lw	$31, 120($sp)
	addiu	$sp, $sp, 132
	eret
	
