	.data

	.extern		_main
	.extern		_sp_base
#===============================
#      PowerPC Exception Vectors
#===============================
	.org	0x100
	# System reset
	b	__startup
	.org	0x500
	# External Interrupt
	b	__global_exception_handler
	.org	0x900
	# Decrementer
	b	__decrementer
	.text
	.global	__startup
__startup:
	bl	main

	.global		__global_exception_handler
__global_exception_handler:
	stwu	r1, -16(r1)
	stw	r0, 4(r1)
	mflr	r0
	stw	r0, 8(r1)
	stw	r2, 12(r1)

	# Ctrl-C$BF~NO$,$"$k$+$I$&$+$rH=Dj$9$k!#(B
	lis	r0, 0xF000
	ori	r0, r0, 0x2004
	li	r2, 0x100
	and	r0, r0, r2
	lwz	r2, 12(r1)
	cmpwi	cr7, r0, 0
	bgt	cr7, __rxint
	
	# Break$BL?Na$,<B9T$5$l$?$+$I$&$+$rH=Dj$9$k!#(B
	/*mfc0	$1, $13
	andi	$1, $1, 0xFF
	addi	$1, $1, -0x24
	beq	$0, $1, __break
	nop*/

	lis	r0, _user_exception_vector_addr@ha
	ori	r0, r0, _user_exception_vector_addr@l
	lwz	r0, 0(r0)
	addi	r0, r0, 0x500
	mtlr	r0
	blr

# $B%f!<%6%W%m%0%i%`$G$O0J2<$N(B3$B9T$rNc30%O%s%I%i$N:G=i$KDI2C$7$J$/$F$O$$$1$J$$!#(B
#	lwz	r0, 8(r1)
#	mtlr	r0
#	lwz	r0, 4(r1)
#	stwu	r1, 0(r1)
	
	
	.global		__rxint	
__rxint:
	lwz	r0, 8(r1)
	mtlr	r0
	lwz	r0, 4(r1)
	stwu	r1, 0(r1)
	
	stwu	r1, -140(r1)
	stw	r0, 4(r1)
	stw	r2, 8(r1)
	stw	r3, 12(r1)
	stw	r4, 16(r1)
	stw	r5, 20(r1)
	stw	r6, 24(r1)
	stw	r7, 28(r1)
	stw	r8, 32(r1)
	stw	r9, 36(r1)
	stw	r10, 40(r1)
	stw	r11, 44(r1)
	stw	r12, 48(r1)
	stw	r13, 52(r1)
	stw	r14, 56(r1)
	stw	r15, 60(r1)
	stw	r16, 64(r1)
	stw	r17, 68(r1)
	stw	r18, 72(r1)
	stw	r19, 76(r1)
	stw	r20, 80(r1)
	stw	r21, 84(r1)
	stw	r22, 88(r1)
	stw	r23, 92(r1)
	stw	r24, 96(r1)
	stw	r25, 100(r1)
	stw	r26, 104(r1)
	stw	r27, 108(r1)
	stw	r28, 112(r1)
	stw	r29, 116(r1)
	stw	r30, 120(r1)
	stw	r31, 124(r1)
	mflr	r0
	stw	r0, 128(r1)
	mfcr	r0
	stw	r0, 132(r1)

	lis	r0, registers@ha
	ori	r0, r0, registers@l
	lwz	r2, 4(r1)
	stw	r2, 0(r0)
	lwz	r2, 0(r1)
	stw	r2, 4(r0)
	lwz	r2, 8(r1)
	stw	r2, 8(r0)
	stw	r3, 12(r0)
	stw	r4, 16(r0)
	stw	r5, 20(r0)
	stw	r6, 24(r0)
	stw	r7, 28(r0)
	stw	r8, 32(r0)
	stw	r9, 36(r0)
	stw	r10, 40(r0)
	stw	r11, 44(r0)
	stw	r12, 48(r0)
	stw	r13, 52(r0)
	stw	r14, 56(r0)
	stw	r15, 60(r0)
	stw	r16, 64(r0)
	stw	r17, 68(r0)
	stw	r18, 72(r0)
	stw	r19, 76(r0)
	stw	r20, 80(r0)
	stw	r21, 84(r0)
	stw	r22, 88(r0)
	stw	r23, 92(r0)
	stw	r24, 96(r0)
	stw	r25, 100(r0)
	stw	r26, 104(r0)
	stw	r27, 108(r0)
	stw	r28, 112(r0)
	stw	r29, 116(r0)
	stw	r30, 120(r0)
	stw	r31, 124(r0)
	mfsrr0	r2
	stw	r2, 256(r0)
	mfcr	r2
	stw	r2, 264(r0)
	mflr	r2
	stw	r2, 268(r0)
	mfxer	r2
	stw	r2, 272(r0)
		
	bl	_int_func

	lwz	r0, 4(r1)
	lwz	r2, 8(r1)
	lwz	r3, 12(r1)
	lwz	r4, 16(r1)
	lwz	r5, 20(r1)
	lwz	r6, 24(r1)
	lwz	r7, 28(r1)
	lwz	r8, 32(r1)
	lwz	r9, 36(r1)
	lwz	r10, 40(r1)
	lwz	r11, 44(r1)
	lwz	r12, 48(r1)
	lwz	r13, 52(r1)
	lwz	r14, 56(r1)
	lwz	r15, 60(r1)
	lwz	r16, 64(r1)
	lwz	r17, 68(r1)
	lwz	r18, 72(r1)
	lwz	r19, 76(r1)
	lwz	r20, 80(r1)
	lwz	r21, 84(r1)
	lwz	r22, 88(r1)
	lwz	r23, 92(r1)
	lwz	r24, 96(r1)
	lwz	r25, 100(r1)
	lwz	r26, 104(r1)
	lwz	r27, 108(r1)
	lwz	r28, 112(r1)
	lwz	r29, 116(r1)
	lwz	r30, 120(r1)
	lwz	r31, 124(r1)
	lwz	r0, 128(r1)
	mtlr	r0
	lwz	r0, 132(r1)
	mtcr	r0
	
	lwz	r1, 0(r1)

	rfi

__break:
	rfi
	
	.global		__illegal_inst
__illegal_inst:
	rfi
__decrementer:	
	stwu	r1, -16(r1)
	stw	r0, 4(r1)
	mflr	r0
	stw	r0, 8(r1)

	lis	r0, _user_exception_vector_addr@ha
	ori	r0, r0, _user_exception_vector_addr@l
	lwz	r0, 0(r0)
	addi	r0, r0, 0x900
	mtlr	r0
	blr
	