// PMCT$B%l%8%9%?(B
#define PMCT *((volatile unsigned char *)0xFFFFF02A)
// PCT$B%l%8%9%?(B
#define PCT *((volatile unsigned char *)0xFFFFF00A)
// PMCCT$B%l%8%9%?(B
#define PMCCT *((volatile unsigned char *)0xFFFFF04A)

void led_on(){
  PCT &= ~(1<<6);
}

void led_off(){
  PCT |= (1<<6);
}

volatile int ITER1 = 100000;
volatile int ITER2 = 50000;
volatile int ITER3 = 300000;


void _global_handler_func(unsigned int ECR){
  int i, j;
  if((ECR&0xFFFF) >= 0x40 && (ECR&0xFFFF) <= 0x4F){
    led_on();
  }
  if((ECR&0xFFFF) >= 0x50 && (ECR&0xFFFF) <= 0x5F){
    for(j=0;j<3;j++){
      led_off();
      for(i=0;i<ITER1;i++){}
      led_on();
      for(i=0;i<ITER2;i++){}
    }
    led_off();
  }
}

#define LOCKR *((volatile unsigned char *)0xFFFFF824)
#define PLLCTL *((volatile unsigned char *)0xFFFFF82C)
#define PRCMD *((unsigned char *)0xFFFFF1FC)
#define PCC *((unsigned char *)0xFFFFF828)

void configure_clock(){
  PRCMD = 0;
  PCC = 0;
  while(LOCKR);
  PLLCTL |= (1<<1);
}

int main(){
  int i, j;

  configure_clock();

  //asm("dbtrap");
  //asm(".long 0x078007E0");

  PMCT &= ~(1<<6);
  PMCCT = 0x00;
  for(j=0;j<10;j++){
    for(i=0;i<ITER3;i++){}
    asm("trap 0x00");
    for(i=0;i<ITER3;i++){}
    asm("trap 0x10");
  }
}

