#ifndef __GDB_STUB_H
#define __GDB_STUB_H

//#define MB_UART
//#define BLANCA_UART

#ifdef BLANCA_UART
#define COM1
//#define COM2
#endif

// VAo͗p̃obt@̍őlłB
// ̃obt@TCYNUMREGBYTES*2ȏȂƂ܂B
#define BUFMAX 4096

// GDBɕ񍐂郌WX^
#define NUMREGS 37

// WX^̓eL^ۂ̃TCYioCgj
// 32rbgA[LeN`̂Ƃ́A4~WX^ɂȂ܂B
#define NUMREGBYTES (NUMREGS*4)

// \ȃu[N|Cg̐
#define MAX_BREAK 32

#define SET_MSR(val)   asm volatile("mts rmsr, %0" : : "r" (val));
#define GET_MSR(val)   asm volatile("mfs %0, rmsr" : "=r" (val) : );

enum regnames
  {
    R0, R1, R2, R3, R4, R5, R6, R7,
    R8, R9, R10, R11, R12, R13, R14, R15,
    R16, R17, R18, R19, R20, R21, R22, R23,
    R24, R25, R26, R27, R28, R29, R30, R31,
    PC, MSR, EAR, ESR, FSR
  };

// VOi̎ވꗗ
// exceptionVectorƔrĂB
#define NO_EXCEPTION  0
#define TERM_EXCEPTION  15
#define USER_VECTOR_EXCEPTION  1
#define INTERRUPT_EXCEPTION 2
#define BREAK_EXCEPTION_SOFT 3
#define BREAK_EXCEPTION_HARD 4
#define HARDWARE_EXCEPTION_ILL_INSN 5
#define HARDWARE_EXCEPTION_BUS_ERR 6

extern struct breakpoint_list breakpoint_addr_list[];

#endif /* __GDB_STUB_H */


