/* SH2t^GDB stub A[LeN`ˑ֐*/

#include <gdb-stub-common.h>
#include "gdb-stub.h"

// SCI1fobO|[gƂėp܂
#define DEBUG_PORT_NUM 1
//#define DEBUG_BAUDRATE 9600
#define DEBUG_BAUDRATE 19200

#define IPRF *((volatile unsigned short *)0xFFFF8352)
#define SCR0 *((volatile unsigned char *)0xFFFF81A2)
#define SCR1 *((volatile unsigned char *)0xFFFF81B2)
#define PBCR2 *((volatile unsigned short *)0xFFFF839A)
#define PCCR *((volatile unsigned short *)0xFFFF839C)
#define BCR1 *((volatile unsigned short *)0xFFFF8620)
#define BCR2 *((volatile unsigned short *)0xFFFF8622)
#define WCR1 *((volatile unsigned short *)0xFFFF8624)
#define PDCRL1 *((volatile unsigned short *)0xFFFF83AC)
#define PACRL1 *((volatile unsigned short *)0xFFFF838C)
#define MSTCR2 *((volatile unsigned short *)0xFFFF861E)
#define UBARH *((volatile unsigned short *)0xFFFF8600)
#define UBARL *((volatile unsigned short *)0xFFFF8602)
#define UBAMRH *((volatile unsigned short *)0xFFFF8604)
#define UBAMRL *((volatile unsigned short *)0xFFFF8606)
#define UBBR  *((volatile unsigned short *)0xFFFF8608)
#define UBCR  *((volatile unsigned short *)0xFFFF860A)
#define MSTCR1 *((volatile unsigned short *)0xFFFF861C)
#define PACRL2 *((volatile unsigned short *)0xFFFF838E)
#define SMR0 *((volatile unsigned char *)0xFFFF81A0)
#define BRR0 *((volatile unsigned char *)0xFFFF81A1)
#define TDR0 *((volatile unsigned char *)0xFFFF81A3)
#define SSR0 *((volatile unsigned char *)0xFFFF81A4)
#define RDR0 *((volatile unsigned char *)0xFFFF81A5)
#define SDCR0 *((volatile unsigned char *)0xFFFF81A6)
#define SMR1 *((volatile unsigned char *)0xFFFF81B0)
#define BRR1 *((volatile unsigned char *)0xFFFF81B1)
#define TDR1 *((volatile unsigned char *)0xFFFF81B3)
#define SSR1 *((volatile unsigned char *)0xFFFF81B4)
#define RDR1 *((volatile unsigned char *)0xFFFF81B5)
#define SDCR1 *((volatile unsigned char *)0xFFFF81B6)
#define SSR0 *((volatile unsigned char *)0xFFFF81A4)
#define RDR0 *((volatile unsigned char *)0xFFFF81A5)
#define SSR1 *((volatile unsigned char *)0xFFFF81B4)
#define RDR1 *((volatile unsigned char *)0xFFFF81B5)
#define TDR0 *((volatile unsigned char *)0xFFFF81A3)
#define SSR0 *((volatile unsigned char *)0xFFFF81A4)
#define TDR1 *((volatile unsigned char *)0xFFFF81B3)
#define SSR1 *((volatile unsigned char *)0xFFFF81B4)
#define TCNT *((volatile unsigned short *)0xFFFF8610)
#define TCSR *((volatile unsigned short *)0xFFFF8610)
#define RSTCSR *((volatile unsigned short *)0xFFFF8612)


  
void enable_int(){
  // M荞݋AMAM
  if(DEBUG_PORT_NUM == 0){
    SCR0 |= (1<<6);
    IPRF |= (0xF<<4);
  }
  else{
    SCR1 |= (1<<6);
    IPRF |= (0xF);
  }
}

void disable_int(){
  // M荞݋֎~
  if(DEBUG_PORT_NUM == 0)
    SCR0 &= ~(1<<6);
  else
    SCR1 &= ~(1<<6);
}

// [Uu[NRg[̃u[N|Cg폜֐
void UBC_clr(unsigned int addr){
  UBARH = 0x0000;
  UBARL = 0x0000;
  UBAMRH = 0;
  UBAMRL = 0;
  UBBR = 0x0000; // CPUTCNA߃tFb`A[h
  UBCR = 1; // u[N  
}

// [Uu[NRg[Ƀu[N|Cgݒ肷֐
int UBC_set(unsigned int addr){
  if((UBARH != 0) || (UBARL != 0))
    return 0;

  MSTCR2 &= ~1;
  UBARH = (short)(((addr)>>16) & 0xFFFF);
  UBARL = (short)((addr) & 0xFFFF);
  UBAMRH = 0;
  UBAMRL = 0;
  UBBR = 0x0054; // CPUTCNA߃tFb`A[h
  UBCR = 0; // u[NL

  return 1;
}

// GDBɒʒmVOiԂ֐B
int computeSignal (int exceptionVector)
{
  int sigval;

  switch (exceptionVector)
    {
    case INT_EXCEPTION:
      sigval = 2;
      break;
    case NO_EXCEPTION:
      sigval = -1;
      break;
    case TERM_EXCEPTION:
      sigval = 15;
      break;
    case INVALID_INSN_VEC:
      sigval = 4;
      break;
    case INVALID_SLOT_VEC:
      sigval = 4;
      break;
    case CPU_BUS_ERROR_VEC:
      sigval = 10;
      break;
    case DMA_BUS_ERROR_VEC:
      sigval = 10;
      break;
    case NMI_VEC:
      sigval = 2;
      break;
    case TRAP_VEC:
    case USER_VEC:
      sigval = 5;
      break;
    default:
      sigval = 7;               /* "software generated"*/
      break;
    }
  return (sigval);

}

// GDBgVA|[g܂B
void init_serial (){
  int i;

  switch(DEBUG_PORT_NUM){
  case 1:
    // SCI1X^oCԂ
    MSTCR1 &= ~0x2;
    // TXD1,RXD1Cl[u 
    PACRL2 = ((1<<8) | (1<<6));
    // 8bit
    // peBȂ
    // Stoprbg1rbg
    SCR1 = 0x0;
    SMR1 = 0x0;
    if(DEBUG_BAUDRATE == 9600)
      // 9600bps (CKS = 00, BRR=77)
      BRR1 = 77;
    else if(DEBUG_BAUDRATE == 19200)
      // 19200bps (CKS = 00, BRR=38)
      BRR1 = 38;
    // 1rbg҂ԁiKɒ҂j
    for(i=0;i<(BRR1*1000);i++){}
    // MAM
    SCR1 = ((1<<5)|(1<<4));
    break;
  case 0:
    // SCI0X^oCԂ
    MSTCR1 &= ~0x1;
    // TXD0,RXD0Cl[u 
    PACRL2 |= ((1<<2) | (1<<0));
    // 8bit
    // peBȂ
    // Stoprbg1rbg
    SCR0 = 0x0;
    SMR0 = 0x0;
    if(DEBUG_BAUDRATE == 9600)
      // 9600bps (CKS = 00, BRR=77)
      BRR0 = 77;
    else if(DEBUG_BAUDRATE == 19200)
      // 19200bps (CKS = 00, BRR=38)
      BRR0 = 38;
    // 1rbg҂ԁiKɒ҂j
    for(i=0;i<(BRR0*1000);i++){}
    // MAM
    SCR0 = ((1<<5)|(1<<4));
    break;
  }
}
    
// VA|[gAGDB̃R}h󂯎܂B
// 1oCgԂ܂B
char getDebugChar (void){
  char recv_char;

  switch(DEBUG_PORT_NUM){
  case 0:
    while((SSR0 & (1<<6)) == 0){}
    recv_char = RDR0;
    SSR0 &= ~(1<<6);
    break;    
  case 1:
    while((SSR1 & (1<<6)) == 0){}
    recv_char = RDR1;
    SSR1 &= ~(1<<6);
    break;
  }

  return recv_char;
}

// 1M֐B
void putDebugChar (char ch){
  switch(DEBUG_PORT_NUM){
  case 0:
    // Mobt@̋󂫂҂
    while((SSR0 & (1<<7)) == 0){}
    // Mf[^
    TDR0 = ch;
    // MJn
    SSR0 = SSR0 & ~(1<<7);
    break;
  case 1:
    // Mobt@̋󂫂҂
    while((SSR1 & (1<<7)) == 0){}
    // Mf[^
    TDR1 = ch;
    // MJn
    SSR1 = SSR1 & ~(1<<7);
    break;
  }  
}

void _illegalinst_func(void){
  gdb_handle_exception(INVALID_INSN_VEC);
}

void _rxint_func(void){
  gdb_handle_exception(INT_EXCEPTION);
}

void _break_func(void){
  gdb_handle_exception(TRAP_VEC);
}

#define EX_SRAM_START 0x400000
#define EX_SRAM_END 0x47ffff
#define EX_SRAM_SIZE (512*1024)

void _init_cs1(void)
{
  volatile unsigned char *cp;
  int i;
  
  PBCR2 = 0x2005; /* A18,A17,A16L */
  PCCR = 0xFFFF; /* A15-A0L */
  BCR1 |= 0x0002; /* CS116bit */
  BCR2 &= 0xFEDD; /* IW1=CW1=SW1=0 */
  WCR1 &= 0xFF1F; /* CS1 1wait */
  PDCRL1 = 0xFFFF; /* D0-D15L */
  PACRL1 = 0x1540; /* RD,WRH,WRHL,CS1L */
  
  /* OSRAMONA */
  cp = (unsigned char *)EX_SRAM_START;
  for ( i=0; i < EX_SRAM_SIZE ; i++) {
    *cp++ = 0x00;
  } 
}

void cpu_init_at_main(){
  _init_cs1();
}

void gdb_stub_kill_command(){
  int i;

  // GDB邽߂̃fBCB
  for(i=0;i<3000000;i++){}
  
  // EHb`hbN^C}[ŃtZbg
  RSTCSR = (0x5A << 8) | (1<<6);
  TCNT = (0x5A << 8) | 0xFF;
  TCSR = (0xA5 << 8) | (1<<6) | (1<< 5);
}
