#define TOCR *((unsigned char *)0xFFD80000)
#define TSTR0 *((unsigned char *)0xFFD80004)
#define TCOR0 *((unsigned int *)0xFFD80008)
#define TCNT0 *((unsigned int *)0xFFD8000C)
#define TCR0 *((unsigned short *)0xFFD80010)
#define TCOR1 *((unsigned int *)0xFFD80014)
#define TCNT1 *((unsigned int *)0xFFD80018)
#define TCR1 *((unsigned short *)0xFFD8001C)

#define INT2PRI0 *((unsigned int *)0xFFD40000)
#define INT2MSKCR *((unsigned int *)0xFFD4003C)


#define BLANCA_LED *((volatile unsigned int *)0xA4C00020)

#define COUNT_VAL 32552

void timer0_exception_func(){
  TCR0 &= ~(1<<8);

  BLANCA_LED = 0xa;

  // $B%?%$%^(B0 $B%9%H%C%W(B
  TSTR0 &= ~1;

  // $B%+%&%s%HCM$r%;%C%H(B
  TCOR1 = COUNT_VAL;
  TCNT1 = COUNT_VAL;

  // $B%?%$%^(B1 $B%9%?!<%H(B
  TSTR0 |= 2;
}

void timer1_exception_func(){
  TCR1 &= ~(1<<8);

  BLANCA_LED = 0x5;

  // $B%?%$%^(B1 $B%9%H%C%W(B
  TSTR0 &= ~2;

  // $B%+%&%s%HCM$r%;%C%H(B
  TCOR0 = COUNT_VAL;
  TCNT0 = COUNT_VAL;

  // $B%?%$%^(B0 $B%9%?!<%H(B
  TSTR0 |= 1;
}

#define INTEVT *((volatile unsigned int *)0xFF000028)

void int_func(){
  if(INTEVT == 0x580)
    timer0_exception_func();
  if(INTEVT == 0x5A0)
    timer1_exception_func();

}

int ITER1 = 500000;
int ITER2 = 300000;

int main(){
  volatile int i,j;


  // $B3d$j9~$_M%@hEY@_Dj(B
  INT2PRI0 = (31 << 24) | (31 << 16);
  // $B%^%9%/%/%j%"(B
  INT2MSKCR = 1;


  // $BFbIt%/%m%C%/$r;H$&(B
  TOCR = 1;

  TCR0 = (1<<5) | (4 << 0);
  TCR1 = (1<<5) | (4 << 0);

  TCOR0 = COUNT_VAL;
  TCOR1 = COUNT_VAL;

  // $B%+%&%s%HCM$r%;%C%H(B
  TCNT0 = COUNT_VAL;
  TCNT1 = COUNT_VAL;

  // $B%?%$%^(B0 $B%9%?!<%H(B
  TSTR0 |= 1;

  while(1){}
  return 0;

}


